﻿@page "/returned/addlist"

@inject HttpClient WebClient
@inject IJSRuntime JSRuntime
@inject ISnackbar Snackbar
@inject IDialogService DialogService
@inject NavigationManager NavigationManager

@using SwP.Fulfillment.ParcelLogger.Shared

<MudForm @ref="_form" @bind-IsValid="@success" @bind-Errors="@errors">
    <MudStack>
        <MudContainer Class="d-flex justify-center align-center" MaxWidth="MaxWidth.Medium">

            <MudTextField @bind-Value="_batchName"
                          Label="Name"
                          Variant="Variant.Outlined"
                          Validation="@(new Func<string, Task<string>>(ListName))"
                            Required
                           RequiredError="Please enter unique name" />
         </MudContainer>
         <MudContainer Class="d-flex justify-center align-center" MaxWidth="MaxWidth.Medium">
             @if (!_form.IsValid)
            {
                <MudFab Color="Color.Primary" StartIcon="@Icons.Material.Filled.Check" Size="Size.Large" OnClick="@(() => _form.Validate())"></MudFab>
            }
            else
            {
                <MudFab Color="Color.Success" StartIcon="@Icons.Material.Filled.Save" Size="Size.Large" OnClick="Add"></MudFab>
            }
        </MudContainer>
    </MudStack>
</MudForm>

@code
{
    bool success;
    string[] errors = { };
    MudForm _form;
    string _batchName = string.Empty;



    async Task<string> ListName(string arg)
    {
        if (string.IsNullOrWhiteSpace(_batchName))
        {
            // _canSave = false;
            var errorMsg = "Name is empty";
            Snackbar.Clear();
            Snackbar.Configuration.PositionClass = Defaults.Classes.Position.BottomCenter;
            Snackbar.Add(errorMsg, Severity.Error);
            return errorMsg;
        }
        if (_batchName.Length > 50)
        {
            // _canSave = false;
            var errorMsg = "Maximum lenght for name is 50";
            Snackbar.Clear();
            Snackbar.Configuration.PositionClass = Defaults.Classes.Position.BottomCenter;
            Snackbar.Add(errorMsg, Severity.Error);
            return errorMsg;
        }
        try
        {
            //check if batch with same name exists
            var response = await WebClient.GetAsync("api/returns");
            response.EnsureSuccessStatusCode(); // Ensure a successful response
            try
            {
                var list = await response.Content.ReadFromJsonAsync<List<RecordsList>>();
                if (list.Any(b => !b.Locked && b.Description == _batchName))
                {
                    //   _canSave = false;
                    var errorMsg = "Name already exists";
                    Snackbar.Clear();
                    Snackbar.Configuration.PositionClass = Defaults.Classes.Position.BottomCenter;
                    Snackbar.Add(errorMsg, Severity.Error);
                    return errorMsg;
                }
            }
            catch
            {

            }



        }
        catch (Exception e)
        {
            // _canSave = false;
            var errorMsg = "Failed to verify record. Please check connection and try again.";
            Snackbar.Clear();
            Snackbar.Configuration.PositionClass = Defaults.Classes.Position.BottomCenter;
            Snackbar.Add(errorMsg, Severity.Error);
            return errorMsg;

        }
        return string.Empty;
    }

    string ShowSnackbarError(string message)
    {
        Snackbar.Clear();
        Snackbar.Configuration.PositionClass = Defaults.Classes.Position.BottomCenter;
        Snackbar.Add(message, Severity.Error);
        return message;
    }

    async Task Add()
    {
        try
        {
            var b = new RecordsList();
            b.Description = _batchName;
            b.Records = new List<Record>();
            b.DateCreated = DateTime.Now;

            //
            var json = System.Text.Json.JsonSerializer.Serialize<RecordsList>(b);
            //
            var response = await WebClient.PostAsJsonAsync("api/returns", b);
            if (response.IsSuccessStatusCode)
            {
                var createdBatch = await response.Content.ReadFromJsonAsync<RecordsList>();


                var parameters = new DialogParameters<Dialog_StartScanning>();
                parameters.Add(x => x.Content, "List saved");
                var dialog = await DialogService.ShowAsync<Dialog_StartScanning>("Return to previous screen?", new DialogOptions() { Position = DialogPosition.TopCenter });
                var result = await dialog.Result;
                if (!result.Cancelled)
                {
                    //NavigationManager.NavigateTo($"./scan/{createdBatch.BatchID}", true);
                    NavigationManager.NavigateTo($"./returned/scanner/"+createdBatch.Id, true);

                }
                else
                {
                    NavigationManager.NavigateTo($"./returned/", true);                    
                }
            }
            else
            {
                var errorMsg = "Failed save list. Please check connection and try again.";
                Snackbar.Clear();
                Snackbar.Configuration.PositionClass = Defaults.Classes.Position.BottomCenter;
                Snackbar.Add(errorMsg, Severity.Error);
                return;

            }



        }
        catch (HttpRequestException ex)
        {
            var errorMsg = "Failed to create record. Please try again.";
            Snackbar.Clear();
            Snackbar.Configuration.PositionClass = Defaults.Classes.Position.BottomCenter;
            Snackbar.Add(errorMsg, Severity.Error);
        }
    }

}